package diplomado;

import java.sql.*;		// JDBC
import java.io.*;		// PrintWriter
import java.text.DecimalFormat;	// DecimalFormat

public class Frijol {
  private Statement declaracion = null;
  private Connection conexion   = null;
  private ResultSet resultado   = null;
  private DecimalFormat numero  = new DecimalFormat("#,##0,000");
  private int consultas         = 0;

  private String pais       = "";
  private String capital    = "";
  private String continente = "";
  private String area       = "";
  private String poblacion  = "";

  private int registro = 1;

  public Frijol() {
    try {
      DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
      try {
        Connection conexion =
          DriverManager.getConnection("jdbc:oracle:thin:@ainsuca.javeriana.edu.co:1521:DB",
                                      "proweb", "proweb");
        try {
          declaracion = conexion.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,
                                                 ResultSet.CONCUR_READ_ONLY);
        } catch (SQLException e) {
          System.err.println("Imposible crear la declaracion");
        }
      } catch (SQLException e) {
        System.err.println("Imposible conectar a la base de datos");
      }
    } catch (SQLException e) {
      System.err.println("Imposible cargar el controlador");
    }
  }

  public void ubicarRegistro(int posicion) {
    registro = posicion;
    try {
      resultado = declaracion.executeQuery("SELECT * FROM Paises");
      try {
        resultado.absolute(registro);
      } catch (SQLException e) {
        System.err.println(e);
      }
    } catch (SQLException e) {
      System.err.println("Error en la ejecucin SQL\n" + e);
    }
  
  }

  public String getPais() {
    try {
      return resultado.getString("Nombre");
    } catch(SQLException e) {
      return "";
    }
  }

  public String getCapital() {
    try {
      return resultado.getString("Capital");
    } catch(SQLException e) {
      return "";
    }
  }

  public String getContinente() {
    try {
      return resultado.getString("Continente");
    } catch(SQLException e) {
      return "";
    }
  }

  public String getArea() {
    try {
      return numero.format(resultado.getInt("Area"));
    } catch(SQLException e) {
      return "";
    }
  }

  public String getPoblacion() {
    try {
      return numero.format(resultado.getInt("Poblacion"));
    } catch(SQLException e) {
      return "";
    }
  }

  public int getRegistro() {
    return registro;
  }

  public void setRegistro(int registro) {
    this.registro = registro;
  }

  public void finalize() {
    try {
      conexion.close();
    } catch (Exception e) {
      System.err.println("Imposible cerrar la base de datos");
    }
  }
}
