// Complejo.java: manejo de nmeros complejos

public class Complejo {
  // Atributos: parte real y parte imaginaria
  private float _real, _imag;

  public Complejo() { // Constructor predeterminado
    this(1, 1); // 1+1i por defecto
  }

  public Complejo(float r, float i){ // Constructor parametrizado
	  _real = r;
	  _imag = i;
  }

  // Accedentes y mutadores

  public float real() { return _real; }

  public float imag() { return _imag; }

  public void real(float r) { _real = r; }

  public void imag(float i) { _imag = i; }

  // Operaciones aritmticas

  public void acumula(Complejo otro) {
  // Acumula en el receptor el complejo proporcionado
    _real += otro._real;
	  _imag += otro._imag;
	}

  public Complejo mas(Complejo otro) {
  // Devuelve la suma del receptor con el complejo proporcionado
    float auxr = _real + otro._real;
    float auxi = _imag + otro._imag;
	  return new Complejo(auxr, auxi);
  }

  public Complejo menos(Complejo otro) {
  // Devuelve la resta del receptor con el complejo proporcionado
    float auxr = _real - otro._real;
    float auxi = _imag - otro._imag;
    return new Complejo(auxr, auxi);
  }

  public Complejo por(Complejo otro) {
  // Devuelve el producto del receptor con el complejo proporcionado
    Complejo comp = new Complejo();
    comp._real = _real * otro._real - _imag * otro._imag;
    comp._imag = _real * otro._imag + _imag * otro._real;
    return comp;
  }

  public Complejo entre(Complejo otro) {
  // Devuelve la divisin del receptor con el complejo proporcionado
    Complejo comp = new Complejo();
    // Hacemos que comp sea el complementario de otro
    comp._real = otro._real;
    comp._imag = - otro._imag;
    // Multiplicamos el receptor por el complementario de otro (comp)
    comp = this.por(comp);
    // Slo queda dividir por la suma de los cuadrados
    // de las partes real e imaginaria de otro
    float divisor = otro._real * otro._real + otro._imag * otro._imag;
    comp._real = comp._real / divisor;
    comp._imag = comp._imag / divisor;
    return comp;
  }

  public void print() {
	  System.out.print("{ " + _real + " , " + _imag + "i }");
 }


}
