// Cuenta.java: una clase Cuenta (bancaria)

public class Cuenta {
  private static long _numero = 100000; // Atributo de clase
  private long _num;
  private long _dni;
  private double _saldo;
  private double _interes;

  // Constructor predeterminado
  public Cuenta() {
    _num = ++_numero;
    _dni = 0;
    _saldo = 0;
    _interes = 0;
  }

  // Constructor parametrizado
  public Cuenta(long dni, double saldo, double interes) {
    _num = ++_numero;
    _dni = dni;
    _saldo = saldo;
    _interes = interes;
  }

  // Accedentes y mutadores

  public long numero() { return _num; }
  public long dni() { return _dni; }
  public double saldo() { return _saldo; }
  public double interes() { return _interes; }
  public void dni(long d) { _dni = d; }
  public void saldo(double s) { _saldo = s; }
  public void interes(double i) { _interes = i; }
  // No hay mutador para el nmero de cuenta (no se puede cambiar).

  public void actualizarSaldo(){
    _saldo += _saldo * (_interes / 365) / 100;
  }

  public void ingresar(double cantidad) {
    _saldo = _saldo + cantidad;
  }

  public boolean retirar(double cantidad) {
  // Devuelve true si se ha podido retirar el dinero
  // y false en caso contrario (no hay saldo suficiente).
    if(_saldo < cantidad) return false;
    _saldo -= cantidad;
    return true;
  }

  public String toString() {
    return "Numero de la cuenta: " + _num
      + "\nD.N.I. del cliente: "+ _dni
      + "\nSaldo: " + _saldo
      + " euros\nInteres anual: " + _interes + " %";
  }
}
