// Clase Empleado

public class Empleado {
  private Nif _nif;
  private double _sueldoBase;
  private double _precioExtra;
  private float _horasMes;
  private float _irpf;
  private boolean _casado;
  private int _nHijos;

  public Empleado() {
    this(0);
  }  
     

  public Empleado(long dni) {
    if (dni==0) _nif = new Nif();
    else _nif = new Nif(dni);
    _sueldoBase = 0;
    _precioExtra = 0;
    _horasMes = 0;
    _irpf =0;
    _casado = false;
    _nHijos = 0;
  }

  //accedentes
  
   public Nif nif(){ return _nif;}
   public double sueldoBase(){ return _sueldoBase;}
   public double precioExtra(){ return _precioExtra;}
   public float horasMes(){ return _horasMes;}
   public float irpf(){ return _irpf;}
   public boolean casado(){ return _casado;}
   public int nHijos(){ return _nHijos;}
   
   //mutadores
  
   public void nif(Nif n){ 
      _nif = n;
   }
   public void sueldoBase(double s){ 
      _sueldoBase = s;
   }
   public void precioExtra(double p){ 
     _precioExtra = p;
   }
   public void horasMes(float h){ 
     _horasMes=h;
   }
   public void irpf(float i){ 
     _irpf=i;
   }
   public void casado(boolean c){ 
     _casado=c;
   }
   public void  nHijos(int n){ 
     _nHijos=n;
   }
   
   
   public double complemento (){
   	return _precioExtra*_horasMes;
   }
   
   public double bruto(){
   	return _sueldoBase + complemento();
   }
   
   public double retenciones(){
   	return _irpf * bruto()/100;
   }
   
   public String toString() {
    String cad = "NO";
    if (_casado) cad="SI";
    return "NIF:" + _nif 
      + "\nSueldo base: " + _sueldoBase
      + "\nprecio Extra: "+ _precioExtra
      + "\nHoras Mes: " + _horasMes
      + "\nIRPF: " + _irpf
      + "\nNmero de hijos : " + _nHijos
      + "\nCasado : "+ cad+"\n"; 
  }
  
  
  public void printAll() {
      String cad = "NO";
      if (_casado) cad="SI";
      System.out.println("NIF:" + _nif); 
      System.out.println("Sueldo base: " + _sueldoBase);
      System.out.println("precio Extra: "+ _precioExtra);
      System.out.println("Horas Mes: " + _horasMes);
      System.out.println("IRPF: " + _irpf);
      System.out.println("Nmero de hijos : " + _nHijos);
      System.out.println("Casado : "+ cad); 
      System.out.println("Complemento : "+ complemento()); 
      System.out.println("Sueldo Bruto : "+ bruto()); 
      System.out.println("retenciones : "+ retenciones()); 
      double neto=bruto()-retenciones();
      System.out.println("Sueldo Neto : "+ neto); 
  }
  
  
  
  public static void main(String args[]) {
 	  
 	  Empleado emp1 = new Empleado();
 	  //utilizamos los mutadores en vez de leer()
 	  emp1.sueldoBase(1000);
 	  emp1.precioExtra(50);
 	  emp1.horasMes(12);
 	  emp1.irpf(15);
 	  emp1.casado(false);
 	  emp1.nHijos(0);
 	  
 	  Empleado emp2 = new Empleado(5260276);
 	  //prueba de toString() y de printAll()
 	  System.out.println(emp1);
 	  emp1.printAll();
 	  System.out.println(emp2);
 	  emp2.printAll();
  }
   
}