// Rectangulo.java: clase Rectangulo (usa la clase Punto)

public class Rectangulo {
  private Punto _esquinaInferiorIzquierda,
                _esquinaInferiorDerecha,
                _esquinaSuperiorIzquierda,
                _esquinaSuperiorDerecha;

  // No hay constructor predeterminado, por lo que
  // no se podrn crear rectngulos por defecto.

  // Constructor parametrizado
  // Acepta los cuatro puntos de sus esquinas.
  public Rectangulo(Punto ii, Punto id, Punto si, Punto sd) {
    _esquinaInferiorIzquierda = ii;
    _esquinaInferiorDerecha = id;
    _esquinaSuperiorIzquierda = si;
    _esquinaSuperiorDerecha = sd;
    // Se debera comprobar que los puntos proporcionados
    // son correctos para que se trate de un rectngulo
    // y no de un paralelogramo sin ngulos rectos.
  }

  // Constructor parametrizado
  // Acepta la base y la altura del rectngulo
  // y lo construyecon esos datos y la esquina
  // inferior izquierda en (0,0).
  public Rectangulo (double base, double altura) {
    _esquinaInferiorIzquierda = new Punto(0, 0);
    _esquinaInferiorDerecha = new Punto(base, 0);
    _esquinaSuperiorIzquierda = new Punto(0, altura);
    _esquinaSuperiorDerecha = new Punto(base, altura);
  }

  public double base() {
    return _esquinaInferiorDerecha.x()
      - _esquinaInferiorIzquierda.x();
  }

  public double altura() {
    return _esquinaSuperiorIzquierda.y()
      - _esquinaInferiorIzquierda.y();
  }

  public double superficie() {
    return _esquinaInferiorIzquierda.distancia(_esquinaInferiorDerecha)
      * _esquinaInferiorIzquierda.distancia(_esquinaSuperiorIzquierda);
  }

  public void desplaza(double deltaX, double deltaY) {
    _esquinaInferiorIzquierda.desplaza(deltaX, deltaY);
    _esquinaInferiorDerecha.desplaza(deltaX, deltaY);
    _esquinaSuperiorIzquierda.desplaza(deltaX, deltaY);
    _esquinaSuperiorDerecha.desplaza(deltaX, deltaY);
  }

  public String toString(){
  	 return _esquinaInferiorIzquierda.toString() + " - "
  	  + _esquinaInferiorDerecha.toString() + " - "
  	  + _esquinaSuperiorIzquierda.toString() + " - "
  	  + _esquinaSuperiorDerecha.toString();
  }
}

