// Sistema.java: clases Contador y Usuario

class Contador {
  public Contador() {
    _contador = 0;
  }
  public Contador(int i) {
    if(i < 0) i = 0;
    _contador = i;
  }
  public int contador() {
    return _contador;
  }
  public void contador(int i) {
    if(i >= 0) _contador = i;
  }
  public void incrementar() {
    _contador++;
  }
  public void decrementar() {
    if(_contador > 0) _contador--;
  }
  void println() {
    System.out.println("Valor del contador: " + _contador);
  }
  private int _contador;
}

class Usuario {
  public Usuario() {
    _total++;
    _idUsuario = _total;
    _accesos = new Contador();
    _fallidos = new Contador();
  }
  public int idUsuario() {
    return _idUsuario;
  }
  public Contador accesos() {
    return _accesos;
  }
  public Contador fallidos() {
    return _fallidos;
  }
  // No hay mutadores, ya que son datos controlados por
  // la propia clase y no deben alterarse
  public void hasAccedido() {
    _accesos.incrementar();
  }
  public void hasFallado() {
    _fallidos.incrementar();
  }
  public void println() {
    System.out.println("El usuario con Id " +
      _idUsuario + " ha accedido " + _accesos.contador() +
      " veces al sistema y ha fallado " +
      _fallidos.contador() + " veces.");
  }
  private static int _total = 0;
  private int _idUsuario;
  private Contador _accesos;
  private Contador _fallidos;
}

public class Sistema {
  // Programa principal
  public static void main(String[] args)
  {
    Usuario u1 = new Usuario();
    u1.println();
    u1.hasAccedido();
    u1.hasAccedido();
    u1.hasFallado();
    u1.println();
    Usuario u2 = new Usuario();
    u2.hasFallado();
    u2.hasFallado();
    u2.hasFallado();
    u2.println();
  }
}
