// Cd.java: una clase para representar cd con canciones

public class Cd {
  private static final int MAX=30;
  private Cancion[] canciones;
  private int contador = 0;

  // Constructor predeterminado
  public Cd() {
    canciones = new Cancion[MAX];
  }

  
  public int numeroCanciones() { return contador; }
  
  public Cancion dameCancion(int num){
  	if ((num<1) || (num>MAX)) return null;
  	else return canciones[num-1];
  }	

  public void grabaCancion(int num, Cancion c){
  	if ((num>=1) && (num<=contador)) canciones[num-1]=c;
  }	
  
  public boolean eliminaCancion(int num){
  	
  	if ((num<1) || (num>contador) || (contador==0)) return false;
  	for (int i=num;i<=contador;i++) 
  	   canciones[i-1]=canciones[i];
  	contador--;
  	return true;
  }	
  
  public boolean agrega(Cancion c) {
  	if (contador==MAX) return false;
  	canciones[contador]=c;
  	contador++;
  	return true;
  }	
  
  public String toString() {
    String cad = "Lista de canciones :\n\n";
    for(int i = 0; i < contador; i++)
      cad += i+1+".-"+canciones[i] + "\n";
    return cad;
  }
  
  public static void main(String args[]) {
    Cancion c1 = new Cancion("Angie", "Rolling Stones");
    Cancion c2 = new Cancion("My way", "Frank Sinatra");
    Cancion c3 = new Cancion("La madre de Jos", "El canto del loco");
    Cancion c4 = new Cancion("Paint it black", "Rolling Stones");
    Cd miCd = new Cd();
    miCd.agrega(c1);
    miCd.agrega(c2);
    miCd.agrega(c3);
    miCd.agrega(c4);
    System.out.println(miCd);
    //cambiamos el orden de grabacin
    miCd.grabaCancion(1,c4);
    miCd.grabaCancion(2,c3);
    miCd.grabaCancion(3,c2);
    miCd.grabaCancion(4,c1);
    Cancion c5 = new Cancion("Yesterday", "The Beatles");
    miCd.agrega(c5);
    System.out.println(miCd);
    miCd.eliminaCancion(5);
    System.out.println(miCd);
    miCd.eliminaCancion(1);
    System.out.println(miCd);
}
}