// Alumno4.java: subclase Alumno con atributo de clase Persona3 y clonable

public class Alumno4 extends Persona3 implements Cloneable {
  private int curso;
  private Persona3 profesor;

  // Constructor predeterminado
  public Alumno4() {
    super();
    curso = 1;
    profesor = null;
  }

  // Constructor parametrizado
  public Alumno4(long dni, int edad, String nombre,
                 String apellidos, int curso, Persona3 profesor) {
    super(dni, edad, nombre, apellidos);
    this.curso = curso;
    this.profesor = profesor;
  }

  // Constructor parametrizado
  public Alumno4(long dni, int edad, String nombre,
                 String apellidos, int curso) {
    super(dni, edad, nombre, apellidos);
    this.curso = curso;
    this.profesor = null;
  }

  // Accedentes

  public int dameCurso() { return curso; }

  public Persona3 dameProfesor() { return profesor; }

  // Mutadores

  public void ponCurso(int curso) { this.curso = curso; }

  public void ponProfesor(Persona3 profesor) { this.profesor = profesor; }

  // Otros mtodos

  public String toString() {
    String cadena = "";
    cadena = super.toString() + "Curso: " + curso + "\n";
    cadena += "Profesor: ";
    if(profesor == null) cadena += "no asignado.";
    else cadena += profesor.nombreCompleto();
    cadena += "\n";
    return cadena;
  }

  public void leer() { // lectura de los datos del alumno
    super.leer();
    System.out.print("Curso: ");
    curso = MyInput.readInt();
  }

  public Object clone() {
    Alumno4 al = (Alumno4) super.clone();
    Persona3 per = (Persona3) profesor.clone();
    al.ponProfesor(per);
    return al;
  }
}
