public abstract class Coche{

	private String conductor;
	private String tipo;
	private String color;
	protected Punto posicion;
	
	
    public Coche(String conductor,String tipo, String color, Punto posicion){
		 this.conductor=conductor;
		 this.tipo=tipo;
		 this.color=color;
		 this.posicion=posicion;
	}
	
	public String dameConductor() { return conductor;}
	public void ponConductor(String conductor){this.conductor=conductor;}
    //.....		 
    
    
    public abstract void avanza();
    public String toString(){
    return "(" + conductor + "," + tipo + ","+color + ","+posicion.toString()+")";
  }
    
}    


class CocheDeportivo extends Coche{
	
	
	public CocheDeportivo(String con,String tip, String col){
	 super(con,tip,col,new Punto(0,100));
	}
	
	public void avanza(){
		 double numero=Math.random();
		 if (numero<0.5) posicion.desplaza(50,0);
		 else posicion.desplaza(30,0);
   }
	
}

class CocheEconomico extends Coche{
	
	public CocheEconomico(String con,String tip, String col,Punto p){
	 super(con,tip,col,p);
	}
	
	public void avanza(){
		 double numero=Math.random();
		 if (numero<0.33) posicion.desplaza(15,0);
		 else posicion.desplaza(35,0);
   }
}

class Taxi extends Coche{
	private int numPlazas;
	public Taxi(String conductor,String tipo,Punto posicion,int numPlazas){
	 super(conductor,tipo,"blanco",posicion);
	 this.numPlazas = numPlazas;
	}
	
	public void avanza(){
		 double numero=Math.random();
		 if (numero<0.33) posicion.desplaza(15,0);
		 else posicion.desplaza(35,0);
   }
   
   public String toString(){
    return super.toString()+","+numPlazas+")";
  }
	
}
