// Lista.java: una lista de Libros

public class ListaLibros {
  private final static int MAX = 100;
  private Libro _array[];
  private int _cont = 0; // Indica la primera posicin libre
  // del array. Igual al nmero de elementos

  public ListaLibros() {
    _array = new Libro[MAX];
  }

  public boolean llena() { return _cont == MAX; }

  public boolean vacia() { return _cont == 0; }

  public int length() { return _cont; }

  public boolean insertarOrden(Libro p) {
  // Devuelve true si se inserta; false si lista llena
  // lo inserta en la posicin apropiada
    if(_cont == MAX) return false;
    
    int i=0;boolean encontrado=false;
    while ((i<_cont)&&(!encontrado)){
    	encontrado=(_array[i].dameTitulo().compareTo(p.dameTitulo()))>0;
    	if (!encontrado) i++;
    }	
    for (int j=_cont-1;j>=i;j--) _array[j+1]=_array[j];	
    _array[i] = p;
    _cont++;
    return true;
  }
  
  
  public int buscar(String parte) {
  // Devuelve la posicin donde lo encuentra 
  // -1 caso contrario
    
    int i=0;boolean encontrado=false;
    while ((i<_cont)&&(!encontrado)){
    	if (_array[i].dameTitulo().indexOf(parte) != -1) encontrado=true;
    	else i++;
    }	
    if (encontrado) return i;
    else return -1;
    
  }
  
  
  public boolean insertar(Libro p) {
  // Devuelve true si se inserta; false si lista llena
  // lo inserta en la posicin apropiada
    if(_cont == MAX) return false;
    _array[_cont] = p;
    _cont++;
    return true;
  }
  
  public void eliminar() {}

  public Libro recuperar(int pos) {
  // true si tiene xito; false si posicin no vlida
  // pos variar de 1 al nmero de elementos
    if((pos < 1) || (pos > _cont)) return null;
    return _array[pos-1];
  }

  public String toString() {
    String cad = "Elementos de la lista:\n\n";
    for(int i = 0; i < _cont; i++)
      cad += _array[i] + "\n";
    return cad;
  }
}