// Punto.java: clase Punto

public class Punto {
  private double _x;
  private double _y;

  public Punto() {
    _x = 0;
    _y = 0;
  }

  public Punto(double cx, double cy) {
    _x = cx;
    _y = cy;
  }

  public double x() { return _x; }
  public double y() { return _y; }
  public void x(double d) { _x = d; }
  public void y(double d) { _y = d; }

  public void desplaza(double deltaX, double deltaY) {
    _x += deltaX;
    _y += deltaY;
  }

  public double distancia(Punto otro) {
    double ox = otro.x();
    double oy = otro.y();
    return Math.sqrt((ox - _x) * (ox - _x) +
      (oy - _y) * (oy - _y));
  }

  // Otro mtodo para visualizar objetos:
  // Mtodo estndar toString() que construye una cadena
  // que representa el objeto.
  // Para construir la cadena se usa el potente operador
  // de concatenacin (+) que permite construir una cadena
  // concatenando cadenas literales y valores.
  // La cadena construida se devuelve como resultado
  // (de clase String, que explicaremos en siguiente tema).
  // As, cuando se usa un objeto de esta clase (Punto)
  // en el argumento del mtodo print() o println()
  // de System.out, se llama automticamente
  // al mtodo toString() de la clase para obtener
  // la representacin de cadena del objeto.
  public String toString(){
    return "(" + _x + "," + _y + ")";
  }
  // A partir de ahora crearemos en las clases el mtodo
  // toString() en lugar del mtodo print().
}
