
import java.awt.*;
import java.awt.event.*;

class Calculadora extends Frame implements ActionListener{


   private TextField   operadorIzquierdo,
                       operadorDerecho;

   private Button      botonSuma,
                       botonResta,
                       botonMultiplicacion,
                       botonDivision,
                       botonBorrado;
                       
   

   public Calculadora()   {
      super        ( "Calculadora");
      setSize      ( 200, 150    );
      setResizable ( false       );
      setLayout    ( null        );
      setLocation  ( 300, 200    );

      // crear y colocar los componentes
      iniciarComponentesGUI();
   }

    private void iniciarComponentesGUI( )   {
      // crear botones
      operadorIzquierdo     = new TextField();
      operadorDerecho    = new TextField();

      botonSuma      = new Button("+");
      botonResta     = new Button("-");
      botonMultiplicacion  = new Button("X");
      botonDivision    = new Button("/");
      botonBorrado     = new Button("BORRAR");


      // posiciones de los botones
      operadorIzquierdo.setBounds ( 20,  40, 75, 25);
      operadorDerecho.setBounds ( 20,  75, 75, 25);

      botonSuma.setBounds (110,  40, 30, 30);
      botonResta.setBounds (150,  40, 30, 30);
      botonMultiplicacion.setBounds (110,  75, 30, 30);
      botonDivision.setBounds (150,  75, 30, 30);
      botonBorrado.setBounds (110, 110, 70, 30);

      // aade esta calculadora como un escuchador
      // ce aciones de los cinco botones
      botonSuma.addActionListener( this );
      botonResta.addActionListener( this );
      botonMultiplicacion.addActionListener( this );
      botonDivision.addActionListener( this );
      botonBorrado.addActionListener( this );

      // aade los botones a la ventana de la calculadora
      add(operadorIzquierdo);
      add(operadorDerecho);

      add(botonSuma);
      add(botonResta);
      add(botonMultiplicacion);
      add(botonDivision);

      add(botonBorrado);
   }



   public void actionPerformed (ActionEvent evento)   {
      Button botonPulsado = (Button) evento.getSource();

      if (botonPulsado == botonBorrado) {
         operadorIzquierdo.setText("");
         operadorDerecho.setText("");
      }
      else {
          calcular( botonPulsado );
      }
   }


   
   private void calcular (Button botonOperador)   {
      float   valorOperandoIzquierdo,
              valorOperandoDerecho,
              resultado = 0f;

      // obtener los dos operandos
      valorOperandoIzquierdo = Float.parseFloat(operadorIzquierdo.getText());
      valorOperandoDerecho 	= Float.parseFloat(operadorDerecho.getText());
       
      // calcular el resultado
      if ( botonOperador == botonSuma ) {
         resultado = valorOperandoIzquierdo + valorOperandoDerecho;
      }
      else if ( botonOperador == botonResta ) {
         resultado = valorOperandoIzquierdo - valorOperandoDerecho;
      }
      else if ( botonOperador == botonDivision ) {
         resultado = valorOperandoIzquierdo / valorOperandoDerecho;
      }
      else if ( botonOperador == botonMultiplicacion ) {
         resultado = valorOperandoIzquierdo * valorOperandoDerecho;
      }
      operadorIzquierdo.setText(Float.toString(resultado));
      operadorDerecho.setText("");
    }


   
   
  public static void main (String args[])   {
      Calculadora calculadora = new Calculadora();
      calculadora.setVisible(true);
	  //calculadora.pack();
      calculadora.show();
   }
 
}
