import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;

public class Puzzle extends Applet implements ActionListener {
	
	private long T0;
	protected Button[][] b;
	protected Button bb;
	protected TextField tf;

	public void init() {
		setLayout(new BorderLayout());
		Panel CP=new Panel(),SP=new Panel();
		tf=new TextField();
		tf.setEditable(false);
		add("North",tf);
		add("Center",CP);
		add("South",SP);
		CP.setLayout(new GridLayout(4,4));
		b=new Button[4][4];
		int k=1;
		for (int j=0;j<4;j++) {
			for (int i=0;i<4;i++) {
				b[i][j]=new Button(Integer.toString(k++));
				CP.add(b[i][j]);
			}
		}
		b[3][3].setLabel("");
		SP.setLayout(new FlowLayout());
		SP.add(bb=new Button("barajar"));
		bb.addActionListener(this);
		for (int j=0;j<4;j++) {
			for (int i=0;i<4;i++) {
				b[i][j].addActionListener(this);
			}
		}
	}

	
	
	public void start() {
		desordenar();
	}

	protected void desordenar() {
		int[][] ord=new int[4][4];
		for (int i=0; i<16; i++) { 
			ord[i%4][i/4]=i+1; 
		}
		ord[3][3]=0;
		Random r=new Random();
		for (int i=0; i<16000; i++) {
			int k=(Math.abs(r.nextInt()))%16;
			int m=k%4,n=k/4,aux=ord[m][n];
			if ((m>0)&&(ord[m-1][n]==0)) { 
				ord[m][n]=ord[m-1][n]; 
				ord[m-1][n]=aux; 
			}
			if ((m<3)&&(ord[m+1][n]==0)) { 
				ord[m][n]=ord[m+1][n]; 
				ord[m+1][n]=aux; 
			}
			if ((n>0)&&(ord[m][n-1]==0)) { 
				ord[m][n]=ord[m][n-1]; 
				ord[m][n-1]=aux; 
			}
			if ((n<3)&&(ord[m][n+1]==0)) { 
				ord[m][n]=ord[m][n+1]; 
				ord[m][n+1]=aux; 
			}
		}
		for (int i=0; i<16; i++) { 
			int k=ord[i%4][i/4];
			if (k>0) { 
				b[i%4][i/4].setLabel(Integer.toString(ord[i%4][i/4])); 
			} else { 
				b[i%4][i/4].setLabel(""); 
			}
		}
		tf.setText("El tiempo est corriendo...");
		T0=System.currentTimeMillis();
	}

	void permuta(Button b1, Button b2) {
		String aux=b1.getLabel();
		b1.setLabel(b2.getLabel());
		b2.setLabel(aux);
	}

	void mueve(int i,int j) {
		if ((i>0)&&(b[i-1][j].getLabel().equals(""))) { 
			permuta(b[i][j],b[i-1][j]); 
		}
		if ((i<3)&&(b[i+1][j].getLabel().equals(""))) { 
			permuta(b[i][j],b[i+1][j]); 
		}
		if ((j>0)&&(b[i][j-1].getLabel().equals(""))) { 
			permuta(b[i][j],b[i][j-1]); 
		}
		if ((j<3)&&(b[i][j+1].getLabel().equals(""))) { 
			permuta(b[i][j],b[i][j+1]); 
		}
	}

	public boolean terminado() {
		for (int i=0; i<15; i++) { 
			if (!b[i%4][i/4].getLabel().equals(Integer.toString(i+1))) { 
				return false;
			}
		}
		return true;
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==bb) { 
			desordenar(); 
		} else {
			for (int j=0;j<4;j++) {
				for (int i=0;i<4;i++) {
					if (e.getSource()==b[i][j]) { 
						mueve(i,j); 
					}
					if (terminado()) {
						int T=(int)((System.currentTimeMillis()-T0)/1000);
						String min=Integer.toString(T/60);
						String seg=Integer.toString(T%60);
						if (seg.length()<2) { 
							seg="0"+seg; 
						}
						tf.setText("Tiempo utilizado (min:seg):"+min+":"+seg);
						T0=System.currentTimeMillis();
					}
				}
			}
		}
	}

}