// Coche.java: una clase Coche
// Estos coches tienen cuatro ruedas, dos puertas y un motor.

public class Coche {
	private Rueda ruedaDelanteraIzquierda,
	              ruedaDelanteraDerecha,
	              ruedaTraseraIzquierda,
	              ruedaTraseraDerecha;
	private Puerta puertaIzquierda,
	               puertaDerecha;
	private Motor motor;

	public Coche() {
		ruedaDelanteraIzquierda = new Rueda();
		ruedaDelanteraDerecha = new Rueda();
		ruedaTraseraIzquierda = new Rueda();
	  ruedaTraseraDerecha = new Rueda();
	  puertaIzquierda = new Puerta();
	  puertaDerecha = new Puerta();
	  motor = new Motor();
	}

	public Motor motor() { return motor; }

  public Puerta puertaIzquierda() { return puertaIzquierda; }

  public Puerta puertaDerecha() { return puertaDerecha; }

  public void encender() { motor.encender(); }

  public void apagar() { motor.apagar(); }

  public void abrirPuerta(char cual) {
    if(cual == 'i') puertaIzquierda.abrir();
    else puertaDerecha.abrir();
  }

  public void cerrarPuerta(char cual) {
    if(cual == 'i') puertaIzquierda.cerrar();
    else puertaDerecha.cerrar();
  }

  public void abrirVentana(char cual) {
    if(cual == 'i') puertaIzquierda.abrirVentana();
    else puertaDerecha.abrirVentana();
  }

  public void cerrarVentana(char cual) {
    if(cual == 'i') puertaIzquierda.cerrarVentana();
    else puertaDerecha.cerrarVentana();
  }

  public void inflar(int i) {
    switch(i) {
      case 1 : ruedaDelanteraIzquierda.inflar(); break;
      case 2 : ruedaDelanteraDerecha.inflar(); break;
      case 3 : ruedaTraseraIzquierda.inflar(); break;
      case 4 : ruedaTraseraDerecha.inflar(); break;
    }
  }

  public void desinflar(int i) {
    switch(i) {
      case 1 : ruedaDelanteraIzquierda.desinflar(); break;
      case 2 : ruedaDelanteraDerecha.desinflar(); break;
      case 3 : ruedaTraseraIzquierda.desinflar(); break;
      case 4 : ruedaTraseraDerecha.desinflar(); break;
    }
  }
}


