// FechaHora.java: una clase FechaHora para instantes histricos.

// Una fecha y una hora - enfoque por composicin (atributos).

public class FechaHora {

  private final static long SPD = 86400; // Segundos Por Da

  // Atributos
  private Fecha _fecha;
  private Hora _hora;

  public FechaHora() {
    _fecha = new Fecha();
    _hora = new Hora();
  }

  public FechaHora(Fecha f) {
    _fecha = f;
    _hora = new Hora();
  }

  public FechaHora(Hora h) {
    _fecha = new Fecha();
    _hora = h;
  }

  public FechaHora(Fecha f, Hora h) {
    _fecha = f;
    _hora = h;
  }

  // Accedentes y mutadores

  public Fecha fecha() { return _fecha; }
  public Hora hora() { return _hora; }
  public void fecha(Fecha f) { _fecha = f; }
  public void hora(Hora h) { _hora = h; }

  // Operaciones aritmticas

  public long menos(FechaHora otra) {
  // Segundos entre la FechaHora y la proporcionada
    return _fecha.diasEntre(otra.fecha()) * SPD
      + _hora.segundosDesde(otra._hora);
  }

  public long menos(Hora otra) {
  // Segundos entre la hora y la proporcionada
    return _hora.segundosDesde(otra);
  }

  public long menos(Fecha otra) {
  // Das entre la fecha y la proporcionada
    return _fecha.diasEntre(otra);
  }

  public void siguiente() {
    _hora.siguiente();
    if(_hora.igualQue(new Hora(0,0,0))) _fecha.siguiente(); // cambio de fecha
  }

  public void anterior() {
    _hora.anterior();
    if(_hora.igualQue(new Hora(23,59,59))) _fecha.anterior(); // da anterior
  }

  // Operaciones relacionales

  public boolean igualQue(FechaHora otra) {
    return (_fecha.igualQue(otra._fecha)) && (_hora.igualQue(otra._hora));
  }

  public boolean menorQue(FechaHora otra) {
    return (_fecha.menorQue(otra._fecha)) ||
      (_fecha.igualQue(otra._fecha)) && (_hora.menorQue(otra._hora));
  }

  public boolean mayorQue(FechaHora otra) {
    return (_fecha.mayorQue(otra._fecha)) ||
      (_fecha.igualQue(otra._fecha)) && (_hora.mayorQue(otra._hora));
  }

  public FechaHora copia() {
    return new FechaHora(_fecha.copia(), _hora.copia());
  }

  public void corta() {
    _fecha.corta();
    System.out.print(" ");
    _hora.print();
  }

  public void larga() {
    _fecha.larga();
    System.out.print(" ");
    _hora.print();
  }
}