// Hora.java: clase para el manejo de instantes del da

public class Hora {

  int _horas, _minutos, _segundos;  // Atributos

  // Constructor predeterminado.
  public Hora() { // La medianoche
    _horas = 0;
    _minutos = 0;
    _segundos = 0;
  }

  // Constructor parametrizado.
  public Hora(int h, int m, int s) {
    _horas = h;
    _minutos = m;
    _segundos = s;
    valida();
  }

  // Lectura de la hora.
  public void leer() {
    System.out.print("Horas: ");
    _horas = MyInput.readInt();
    System.out.print("Minutos: ");
    _minutos = MyInput.readInt();
    System.out.print("Segundos: ");
    _segundos = MyInput.readInt();
    valida();
  }

  private void valida() {
    if(_horas < 0) _horas = 0;
    else _horas = _horas % 24;
    if(_minutos < 0) _minutos = 0;
    else _minutos = _minutos % 60;
    if(_segundos < 0) _segundos = 0;
    else _segundos = _segundos % 60;
  }

  // Accedentes y mutadores:

  public int horas() { return _horas; }

  public int minutos() { return _minutos; }

  public int segundos() { return _segundos; }

  public void horas(int h) { _horas = h; valida(); }

  public void minutos(int m) { _minutos = m; valida(); }

  public void segundos(int s) { _segundos = s; valida(); }

  public void print() {
    if(_horas < 10) System.out.print("0");
    System.out.print(_horas + ":");
    if(_minutos < 10) System.out.print("0");
    System.out.print(_minutos + ":");
    if(_segundos < 10) System.out.print("0");
    System.out.print(_segundos);
  }

  private void deSegundos(long seg) {
  // Establece la hora en aquella que corresponde
  // a haber pasado seg segundos desde la medianoche.
    final long SPD = 86400; // Segundos Por Da
    seg %= SPD;
    _horas = (int) seg / 3600;
    seg %= 3600;
    _minutos = (int) seg / 60;
    _segundos = (int) seg % 60;
  }

  private long aSegundos() {
  // Segundos transcurridos desde la medianoche
    return _horas * 3600 + _minutos * 60 + _segundos;
  }

  public long segundosDesde(Hora otra) {
    return aSegundos() - otra.aSegundos();
  }

  public void siguiente() {
    deSegundos(aSegundos() + 1);
  }

  public void anterior() {
    deSegundos(aSegundos() - 1);
  }

  public Hora copia() {
    return new Hora(_horas, _minutos, _segundos);
  }

  public boolean menorQue(Hora otra) {
    return aSegundos() < otra.aSegundos();
  }

  public boolean igualQue(Hora otra) {
    return aSegundos() == otra.aSegundos();
  }

  public boolean mayorQue(Hora otra) {
    return aSegundos() > otra.aSegundos();
  }
};
