// CicloVidaApplet.java

import java.applet.Applet;
import java.awt.Graphics;

/**
 * Demuestra el ciclo de vida de
 * un applet, llevando la cuenta
 * del nmero de veces que se invocan
 * los mtodos init(), start(), paint(),
 * stop() y destroy()
 */
public class CicloVida extends Applet {

    /* Contadores para los mtodos de inters */
    int numInit    = 0;
    int numStart   = 0;
    int numStop    = 0;
    int numDestroy = 0;
    int numPaint   = 0;

    public void init() {
        ++numInit;
    }

    public void start() {
        ++numStart;
    }

    public void stop() {
        ++numStop;
    }

    public void destroy() {
        ++numDestroy;
    }

    /** Escribe el contador de cada mtodo */
    public void paint(Graphics g) {
        ++numPaint;
        g.drawString("Invocaciones a init(): " +
            numInit, 25, 25);
        g.drawString("Invocaciones a start(): " +
            numStart, 25, 50);
        g.drawString("Invocaciones a stop(): " +
            numStop, 25, 75);
        g.drawString("Invocaciones a destroy(): " +
            numDestroy, 25, 100);
        g.drawString("Invocaciones a paint(): " +
            numPaint, 25, 125);
    }

}
