

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;



abstract class Figura { 
  abstract double area();
}

class Circulo extends Figura {

    private int X,Y; //centro
    private int R;

	void setX(int x) { X=x; }
	void setY(int y) { Y=y; }
	int getX() { return X; }
	int getY() { return Y; }
	void moveRight(int d) { X=X+d; }
	void moveLeft (int d) { X=X-d; }
	void moveDown (int d) { Y=Y+d; }
	void moveUp   (int d) { Y=Y-d; }
	
	void setR(int r) { R=r; }
	int getR() { return R; }
	void incRadius(int d) { R=R+d; }
	void decRadius(int d) { R=R-d; if (R<0) { R=0; } }
	double area () { return Math.PI * Math.pow(R, 2);    }

	public Circulo(int x,int y,int r) {
		X=x;
		Y=y;
		R=r;
	}
}

class Cuadrado extends Figura {
  double lado;
  Cuadrado (double lado) { this.lado= lado; }
  double getLado () { return lado;  }
  double area () {    return Math.pow(lado, 2);    }	 
}

class Triangulo extends Figura {
  double base,altura;
  Triangulo (double base,double altura) {
    this.base= base;
	this.altura=altura;  }
  double getBase () { return base;  }
  double getAltura () {return altura;  }	
  double area () { return base*altura/2;  
  }	 
}









public class CircApplet extends JApplet {
	
	Circulo c;
	Container p;
	Panel pan=new Panel();
	Button[] b=new Button[6];
	Color color=new Color(240,120,60);

	public void left()   { c.moveLeft(10);  }
	public void right()  { c.moveRight(10);  }
	public void up()     { c.moveUp(10);  }
	public void down()   { c.moveDown(10);  }
	public void incR()   { c.incRadius(5);  }
	public void decR()   { c.decRadius(5);  }
	public void redraw() { repaint();  }


	public void init() {
		p=getContentPane();
		b[0]=new Button("X-");
		b[1]=new Button("X+");
		b[2]=new Button("Y+");
		b[3]=new Button("Y-");
		b[4]=new Button("R+");
		b[5]=new Button("R-");

		setBackground(Color.black);
		p.setLayout(new BorderLayout());
		p.add("South",pan);
		pan.setLayout(new GridLayout(1,6));
		for (int i=0; i<6;i++) { 
			pan.add(b[i]); 
			b[i].addActionListener(new OyenteBoton());
		}
	}

	public void start() {
		c=new Circulo(getSize().width/2,
			 (getSize().height-pan.getSize().height)/2,40);
	}

	public class OyenteBoton implements ActionListener 	{
	  
	  public void actionPerformed(ActionEvent e) {
		for (int i=0;i<6;i++) {
			if (e.getSource()==b[i]) {
				switch (i) {
				case 0 : left();  break;
				case 1 : right(); break;
				case 2 : down();  break;
				case 3 : up();    break;
				case 4 : incR();  break;
				case 5 : decR();  break;
				}
				repaint();
				break;
			}
		}
	 }
	}

	public void paint(Graphics g) {
		g.setColor(color);
		g.fillOval(c.getX()-c.getR(),c.getY()-c.getR(),2*c.getR(),2*c.getR());
	} 

}