import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

abstract class Figura { 
	
	int x,y,r;
	abstract void dibujar(Graphics g);
	Figura(int x,int y,int r,Color c) {
		this.x=x; 
		this.y=y; 
		this.r=r; 
		this.c=c;	}
	
	void paint(Graphics g) {
		g.setColor(c);
		dibujar(g);
	}
}


class Cuadrado extends Figura {
	Cuadrado(int x,int y,int r,Color c) {
		super(x,y,r,c);	}
	void dibujar(Graphics g) {
		g.drawRect(x-r,y-r,2*r,2*r);
	}

}


class Triangulo extends Figura {
	Triangulo(int x,int y,int r,Color c) {
		super(x,y,r,c);	}
	void dibujar(Graphics g) {
		g.drawLine(x-r,y-r,x-r,y+r);
		g.drawLine(x-r,y+r,x+r,y+r);
		g.drawLine(x+r,y+r,x-r,y-r);
	}
}

class Circunferencia extends Figura {
	Circunferencia(int x,int y,int r,Color c) {
		super(x,y,r,c);
	}

	void dibujar(Graphics g) {
		g.drawOval(x-r,y-r,2*r,2*r);
	}
}

public class Dibujador extends JApplet {

	Container p;
	Figura cd;
	Button b1,b2,b3;

	public void init() {
		p=getContentPane();
		p.setLayout(new FlowLayout());
		p.setBackground(Color.black);
		p.add(b1=new Button("tringulo"));
		p.add(b2=new Button("cuadrado"));
		p.add(b3=new Button("circunferencia"));
		b1.addActionListener(new OyenteBoton());
		b2.addActionListener(new OyenteBoton());
		b3.addActionListener(new OyenteBoton());
	}

	
	class OyenteBoton implements ActionListener 	{
	
	public void actionPerformed(ActionEvent e) {
		int x=p.getSize().width/2;
		int y=p.getSize().height/2;
		int r=(p.getSize().width+p.getSize().height)/8;
		Color c=Color.yellow;
		if (e.getSource()==b1) { cd=new Triangulo(x,y,r,c); }
		else if (e.getSource()==b2) { cd=new Cuadrado(x,y,r,c); }
		else if (e.getSource()==b3) { cd=new Circunferencia(x,y,r,c); }
		repaint();
    	}
	}

	public void paint(Graphics g) {
		if (cd!=null) { 
			cd.paint(g); 
		}
	}

}

