

import java.awt.*;

public abstract class Grafico {
    public static final int TARTA=1;
    public static final int BARRAS=0;
    protected int x, y;                     //posicin del origen
    protected int ancho, alto;              //dimensiones del grfico
    public static final int MAXDATOS=10;
    protected double[] valores=new double[MAXDATOS];
    protected int n;                         //nmero de valores
 //colores del grfico
    protected static final Color colores[]={new Color(255,0,0), new Color(0, 255,0), new Color(0, 0, 255),
          new Color(0, 255, 255), new Color(255, 0, 255), new Color(255, 255, 0),
          new Color(128, 0, 0), new Color(255, 128, 0),
          new Color(128, 128, 255), new Color(255, 0, 128)};

    public Grafico(int x, int y, int ancho, int alto, double[] valores) {
        this.x=x;
        this.y=y;
        this.ancho=ancho;
        this.alto=alto;
        this.valores=valores;
        n=valores.length;
        double maximo=0.0;
        for (int i=0; i<n; i++) {
            if (Math.abs(valores[i])>maximo){
                  maximo = Math.abs(valores[i]);
            }
        }
      for (int i=0; i<n; i+=1) {
            valores[i] = valores[i]/maximo;
      }
  }
  public abstract void dibuja(Graphics g);
}

class GraficoBarras extends Grafico {
   public GraficoBarras(int x, int y, int ancho, int alto, double[] valores) {
      super (x, y, ancho, alto, valores);
    }
   public void dibuja (Graphics g) {
      int anchoBarra=3*ancho/(4*n);
      int dx = ancho/n;
      int h;
      for(int i=0; i<n; i++) {
            g.setColor (colores[i]);
            h=(int)(valores[i]*alto);
            g.fill3DRect (x+dx*i, y-h, anchoBarra, h, true);
      }
   }
}

class GraficoTarta extends Grafico {
   public GraficoTarta(int x, int y, int ancho, int alto, double[] valores) {
      super (x, y, ancho, alto, valores);
   }
   public void dibuja (Graphics g) {
        double total = 0.0;
        for (int i=0; i<n; i+=1) {
            total += valores[i];
        }
        int angulo = 0, incAngulo;
        for(int i=0; i<n; i++) {
            incAngulo=(int)(360.0*valores[i]/total);
            g.setColor (colores[i]);
            g.fillArc (x, y-alto, ancho, alto,   angulo, incAngulo);
            angulo+=incAngulo;
      }
  }
}


