interface Puerta {
   public void abrir();
   public void  cerrar();
}


interface Alarma {
   public boolean alarmaActivada();
   public void  activarAlarma();
   public vois desactivarAlarma();
}


interface PuertaBloqueable extends Puerta {
   public void bloquea();
   public void desbloquea();
}

class ComponentedeCoche   {
   private int descripcion;
   private float peso;
   private float coste;

   public void muestra()   {
      System.out.println( "Esto es la parte de un coche" );
   }
}


class PuertaCoche extends ComponentedeCoche implements PuertaBloqueable, Alarm {

   private boolean estaBloqueada = false;
   private boolean estaActivadaAlarma = false;

   public boolean alarmaActivada() {return estaActivadaAlarma;   }
   public void activarAlarma()   {   estaActivadaAlarma = true; }
   public void desactivarAlarma() {   estaActivadaAlarma  = false; }
   public void abrir() {
      if (estaActivadaAlarma ) 
         System.out.println( "Suena la alarma");
      else if ( !estaBloqueada)
         System.out.println( "Puede entrar en el coche" );
   }

   public void cerrar() {
      System.out.println( "Cerrando la puerta ");
   }

   public void bloquea() {   estaBloqueada = true;   }
   public void desbloquea() {   estaBloqueada = false;   }


   public static void main( String[] args ) {
      PuertaCoche p1 = new PuertaCoche();
      p1.abrir();
	  p1.bloquea();
	  p1.abrir();
	  p1.activarAlarma();
	  p1.abrir();
   }
}


