import java.awt.*;
import java.awt.event.*;
import javax.swing.*;



public class Semaforo extends JApplet implements ActionListener{
	private static LucesSemaforo ls;
	private static AccionRojo ar;
	private static AccionAmbar aa;
	private static AccionVerde av;
	private BotonesSemaforo bs;
	private static BorderLayout bl;
	
	public void init() {
		ls = new LucesSemaforo();
		ar = new AccionRojo(ls);
		aa = new AccionAmbar(ls);
		av = new AccionVerde(ls);
		bs = new BotonesSemaforo(this);
		/* Mens */
		/* Colocacin de paneles */
		bl = new BorderLayout();
		getContentPane().setLayout(bl);
		getContentPane().add("Center", ls);
		getContentPane().add("South", bs);
	}
	
	
	
	public ActionListener getAccionRojo() { return ar; }
	public ActionListener getAccionAmbar() { return aa; }
	public ActionListener getAccionVerde() { return av; }
	public void actionPerformed(ActionEvent e) {
		System.exit(0);
	}
	
};

class AccionRojo implements ActionListener {
	AccionRojo(LucesSemaforo luces) {
		l = luces;
	}
	public void actionPerformed(ActionEvent e) {
		l.ponerRojo();
	}
	private LucesSemaforo l;
};
class AccionVerde implements ActionListener {
	AccionVerde(LucesSemaforo luces) {
		l = luces;
	}
	public void actionPerformed(ActionEvent e) {
		l.ponerVerde();
	}
	private LucesSemaforo l;
};
class AccionAmbar implements ActionListener {
	AccionAmbar(LucesSemaforo luces) {
		l = luces;
	}
	public void actionPerformed(ActionEvent e) {
		l.ponerAmbar();
	}
	private LucesSemaforo l;
};


class BotonesSemaforo extends JPanel {
  private JButton bRojo, bAmbar, bVerde;
	BotonesSemaforo(Semaforo s) {
		bRojo = new JButton("Rojo");
		bRojo.addActionListener(s.getAccionRojo());
		bAmbar = new JButton("Ambar");
		bAmbar.addActionListener(s.getAccionAmbar());
		bVerde = new JButton("Verde");
		bVerde.addActionListener(s.getAccionVerde());
		add(bRojo);
		add(bAmbar);
		add(bVerde);
	}
	
};
class LucesSemaforo extends JPanel {


  public static final Color	rojoEncendido = Color.red.brighter().brighter(),
								rojoApagado = Color.red.darker().darker(),
								verdeEncendido = Color.green.brighter().brighter(),
								verdeApagado = Color.green.darker().darker(),
								ambarEncendido = Color.yellow.brighter().brighter(),
								ambarApagado = Color.yellow.darker().darker();

	private Color tonoRojo, tonoAmbar, tonoVerde;
	private int dimx, dimy, x, radio, diametro, separacion;
	LucesSemaforo() {
		tonoRojo = rojoApagado;
		tonoAmbar = ambarApagado;
		tonoVerde = verdeApagado;
	}
	void ponerRojo() {
		tonoRojo = rojoEncendido;
		tonoAmbar = ambarApagado;
		tonoVerde = verdeApagado;
		repaint();
	}
	void ponerAmbar() {
		tonoRojo = rojoApagado;
		tonoAmbar = ambarEncendido;
		tonoVerde = verdeApagado;
		repaint();
	}
	void ponerVerde() {
		tonoRojo = rojoApagado;
		tonoAmbar = ambarApagado;
		tonoVerde = verdeEncendido;
		repaint();
	}
	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		dimx = getSize().width;
		dimy = getSize().height*4/5;
		x = dimx / 2 - radio;
		separacion = dimy/16;
		radio = dimy / 6;
		diametro = 2*radio;
		g.setColor(tonoRojo);
		/* Ojo: la posicinn entregada a fillOval corresponde
		a la esquina superior izquierda del valo, no a su radio */
		g.fillOval(x, separacion, diametro, diametro);
		g.setColor(tonoAmbar);
		g.fillOval(x, 2*separacion+diametro, diametro, diametro);
		g.setColor(tonoVerde);
		g.fillOval(x, 3*separacion+2*diametro, diametro, diametro);
	}
	
}