import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

public class Ejercicio9 extends JFrame {
  Container panel;
  JPanel botonera, sur;
  JButton[][] botones = new JButton[4][4];
  int[][] array = new int[4][4];
  int blancaI, blancaJ;
  JButton barajar = new JButton("Volver a empezar");
  JButton terminar = new JButton("Salir");

  public Ejercicio9() {
    super("Puzzle");
    panel = this.getContentPane();
    panel.setLayout(new BorderLayout());
    sur = new JPanel();
    sur.setLayout(new FlowLayout());
    sur.add(barajar);
    barajar.addActionListener(new Oyente());
    sur.add(terminar);
    terminar.addActionListener(new Oyente());
    panel.add("South", sur);
    botonera = new JPanel();
    botonera.setLayout(new GridLayout(4, 4));
    panel.add("Center", botonera);
    int num = 1;
    for(int i = 0; i < 4; i++)
      for(int j = 0; j < 4; j++) {
        botones[i][j] = new JButton();
        botones[i][j].addActionListener(new Oyente());
        botonera.add(botones[i][j]);
        array[i][j] = num++;
      }
    array[3][3] = 0;
    // desordenar();
    actualizar();
    setSize(400, 400);
    setVisible(true);
    setDefaultCloseOperation(EXIT_ON_CLOSE);
  }

  public void actualizar() {
    for(int i = 0; i < 4; i++)
      for(int j = 0; j < 4; j++)
        if(array[i][j] == 0) {
//          botones[i][j].setText("");
          botones[i][j].setIcon(null);
          blancaI = i;
          blancaJ = j;
        }
//        else botones[i][j].setText(Integer.toString(array[i][j]));
        else botones[i][j].setIcon(new ImageIcon("boton" + array[i][j] + ".jpg"));
  }

  public void desordenar() {
    Random r = new Random();
    for(int k = 0; k < 1000; k++) {
      int i1 = (Math.abs(r.nextInt())) % 4;
      int j1 = (Math.abs(r.nextInt())) % 4;
      int i2 = (Math.abs(r.nextInt())) % 4;
      int j2 = (Math.abs(r.nextInt())) % 4;
      int tmp = array[i1][j1];
      array[i1][j1] = array[i2][j2];
      array[i2][j2] = tmp;
    }
  }

  public boolean adyacente(int botonI, int botonJ) {
    if(Math.abs(blancaI - botonI) + Math.abs(blancaJ - botonJ) == 1) return true;
    else return false;
  }

  public boolean resuelto() {
    boolean OK = true;
    int num = 1;
    for(int i = 0; i < 4; i++)
      for(int j = 0; j < 4; j++)
        if(num != 16)
          if(array[i][j] != num++) OK = false;
    return OK;
  }

  public static void main(String args[]) {
    Ejercicio9 ventana = new Ejercicio9();
  }

  class Oyente implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      int botonI = 0, botonJ = 0;
      if(e.getSource() == terminar) System.exit(0);
      else if(e.getSource() == barajar) {
        desordenar();
        actualizar();
      }
      else {
        for(int i = 0; i < 4; i++)
          for(int j = 0; j < 4; j++)
            if(e.getSource() == botones[i][j]) {
              botonI = i;
              botonJ = j;
            }
        if(adyacente(botonI, botonJ)) {
          array[blancaI][blancaJ] = array[botonI][botonJ];
          array[botonI][botonJ] = 0;
        }
        actualizar();
        if(resuelto())
          JOptionPane.showMessageDialog(null, "Enhorabuena! Lo conseguiste.",
            "Tu ganas", JOptionPane.INFORMATION_MESSAGE);
      }
    }
  }
}
